package hu.bme.mit.socialnetwork.graphiti.features;

import org.eclipse.graphiti.features.IFeatureProvider;
import org.eclipse.graphiti.features.context.IAddConnectionContext;
import org.eclipse.graphiti.features.context.IAddContext;
import org.eclipse.graphiti.features.impl.AbstractAddFeature;
import org.eclipse.graphiti.mm.algorithms.Polyline;
import org.eclipse.graphiti.mm.pictograms.Connection;
import org.eclipse.graphiti.mm.pictograms.PictogramElement;
import org.eclipse.graphiti.services.Graphiti;
import org.eclipse.graphiti.services.IGaService;
import org.eclipse.graphiti.services.IPeCreateService;
import org.eclipse.graphiti.util.ColorConstant;
import org.eclipse.graphiti.util.IColorConstant;

import socialnetwork.Acquaintance;

public class AddAcquaintanceFeature extends AbstractAddFeature {

	private static final IColorConstant ACQUAINTANCE_COLOR = new ColorConstant(98, 131, 167);
	
	public AddAcquaintanceFeature(IFeatureProvider fp) {
		super(fp);
	}

	@Override
	public boolean canAdd(IAddContext context) {
		return (context instanceof IAddConnectionContext
				&& context.getNewObject() instanceof Acquaintance);
	}

	@Override
	public PictogramElement add(IAddContext context) {
		IAddConnectionContext addContext = (IAddConnectionContext) context;
		Acquaintance acq = (Acquaintance) context.getNewObject();
		
		IPeCreateService peService = Graphiti.getPeCreateService();
		IGaService gaService = Graphiti.getGaService();
		
		//Polyline connection
		Connection connection = peService.createFreeFormConnection(getDiagram());
		connection.setStart(addContext.getSourceAnchor());
		connection.setEnd(addContext.getTargetAnchor());
		
		Polyline line = gaService.createPolyline(connection);
		line.setWidth(2);
		line.setForeground(manageColor(ACQUAINTANCE_COLOR));
		
		link(connection, acq);
		return connection;
	}

}
