package hu.bme.mit.socialnetwork.graphiti.features;

import org.eclipse.graphiti.examples.common.ExampleUtil;
import org.eclipse.graphiti.features.IFeatureProvider;
import org.eclipse.graphiti.features.context.ICreateContext;
import org.eclipse.graphiti.features.impl.AbstractCreateFeature;
import org.eclipse.graphiti.mm.pictograms.Diagram;

import socialnetwork.Person;
import socialnetwork.SocialnetworkFactory;

public class PersonCreateFeature extends AbstractCreateFeature {

	private final static String TITLE = "Create Person";
	private final static String USER_QUESTION = "Enter Name of Person";
	
	public PersonCreateFeature(IFeatureProvider fp) {
		super(fp, "Person", "Create a Person");
	}

	@Override
	public boolean canCreate(ICreateContext context) {
		return context.getTargetContainer() instanceof Diagram;
	}

	@Override
	public Object[] create(ICreateContext context) {
		String name = ExampleUtil.askString(TITLE, USER_QUESTION, "");
		if (name == null || name.trim().length() == 0){
			return EMPTY;
		}
		
		Person person = SocialnetworkFactory.eINSTANCE.createPerson();
		
		getDiagram().eResource().getContents().add(person);
		person.setName(name);
		
		addGraphicalRepresentation(context, person);
		return new Object[] {person};
	}

}
