package hu.bme.mit.socialnetwork.graphiti.features;

import org.eclipse.graphiti.features.IFeatureProvider;
import org.eclipse.graphiti.features.context.IPasteContext;
import org.eclipse.graphiti.features.context.impl.AddContext;
import org.eclipse.graphiti.mm.pictograms.Diagram;
import org.eclipse.graphiti.mm.pictograms.PictogramElement;
import org.eclipse.graphiti.ui.features.AbstractPasteFeature;

import socialnetwork.Person;

public class PersonPasteFeature extends AbstractPasteFeature {

	public PersonPasteFeature(IFeatureProvider fp) {
		super(fp);
	}

	@Override
	public boolean canPaste(IPasteContext context) {
		final PictogramElement[] pes = context.getPictogramElements();
		if (pes.length != 1 || !(pes[0] instanceof Diagram)) {
			//Only allow pasting into the diagram area
			return false;
		}

		Object[] fromClipboard = getFromClipboard();
		if (fromClipboard == null || fromClipboard.length == 0) {
			return false;
		}
		for (Object obj : fromClipboard) {
			if (!(obj instanceof Person)) {
				return false;
			}
		}
		
		
		return true;
	}
	@Override
	public void paste(IPasteContext context) {
		final PictogramElement[] pes = context.getPictogramElements();
		Diagram diagram = (Diagram) pes[0];
		
		Object[] objects = getFromClipboard();
		for (Object obj : objects) {
			AddContext ac = new AddContext();
			ac.setLocation(context.getX(), context.getY());
			ac.setTargetContainer(diagram);
			addGraphicalRepresentation(ac, obj);
		}
	}


}
